Imports I8123W_Net

Public Class Form1

    Dim SLOT As Byte
    Dim BAUD As Byte
    Dim NODE As Byte

    Dim BlockMode As Byte = 1

    Dim DelayTime As UInt16
    Dim ret As UInt16
    Dim errstr As String

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SLOT = 0
        BAUD = 0
        NODE = 1

        Combo_Slot.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Combo_Slot.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 0
        Combo_Node.SelectedIndex = 0

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Pal_PDO.Enabled = False

    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Call I8123W.I8123_ShutdownMaster(SLOT)
    End Sub

    Private Sub Combo_Slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Slot.SelectedIndexChanged
        SLOT = Combo_Slot.SelectedIndex
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        BAUD = Combo_Baud.SelectedIndex

        Select Case (BAUD)
            Case 0
                DelayTime = 15
            Case 1
                DelayTime = 7
            Case 2
                DelayTime = 3
            Case 3
            Case 4
                DelayTime = 1
            Case 5
            Case 6
            Case 7
                DelayTime = 0
        End Select
    End Sub

    Private Sub Combo_Node_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Node.SelectedIndexChanged
        NODE = Combo_Node.SelectedIndex + 1
    End Sub

    Private Sub Btn_Initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Initial.Click

        ret = I8123W.I8123_InitMaster(SLOT, 0, BAUD, BlockMode)
        If ret <> 0 Then
            errstr = "Initial Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Slot.Enabled = False
            Combo_Baud.Enabled = False
            Combo_Node.Enabled = True

            Btn_Initial.Enabled = False
            Btn_Initial.Visible = False
            Btn_Shutdown.Enabled = True

            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
        End If
    End Sub

    Private Sub Btn_Shutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Shutdown.Click

        ret = I8123W.I8123_ShutdownMaster(SLOT)
        If ret <> 0 Then
            errstr = "Shutdown Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Slot.Enabled = True
            Combo_Baud.Enabled = True
            Combo_Node.Enabled = False

            Btn_Initial.Enabled = True
            Btn_Initial.Visible = True
            Btn_Shutdown.Enabled = False

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = True
            Btn_Remove.Enabled = False

            Pal_PDO.Enabled = False

            Timer1.Enabled = False

        End If
    End Sub

    Private Sub Btn_AddNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_AddNode.Click

        ret = I8123W.I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode)
        If ret <> 0 Then
            errstr = "AddNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_Remove.Enabled = True
            Combo_Node.Enabled = False

            Combo_PDOLen.SelectedIndex = 0

            Pal_PDO.Enabled = True

            Timer1.Enabled = True
        End If
    End Sub

    Private Sub Btn_Remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Remove.Click

        ret = I8123W.I8123_RemoveNode(SLOT, NODE, BlockMode)
        If ret <> 0 Then
            errstr = "RemoveNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Btn_Remove.Enabled = False
            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
            Combo_Node.Enabled = True

            Pal_PDO.Enabled = False

            Timer1.Enabled = False
        End If
    End Sub

    Private Sub Btn_Clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Clear.Click
        List_PDOData.Items.Clear()
    End Sub

    Private Sub Check_Is_Hex(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Text_D7.KeyPress, Text_D6.KeyPress, Text_D5.KeyPress, Text_D4.KeyPress, Text_D3.KeyPress, Text_D2.KeyPress, Text_D1.KeyPress, Text_D0.KeyPress, Text_COBID.KeyPress
        If ((("1234567890ABEDCFabcdef".IndexOf(e.KeyChar) <> -1) Or (Convert.ToInt16(e.KeyChar) = 8)) = False) Then e.Handled = True
    End Sub

    Private Sub Btn_PDOWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_PDOWrite.Click
        Dim i As UShort, CobId As UShort
        Dim Len As Byte
        Dim TData(8) As Byte
        Dim DataStr As String

        CobId = Convert.ToUInt16(Text_COBID.Text, 16)
        Len = Combo_PDOLen.SelectedIndex + 1

        TData(0) = Convert.ToByte(Text_D0.Text, 16)
        TData(1) = Convert.ToByte(Text_D1.Text, 16)
        TData(2) = Convert.ToByte(Text_D2.Text, 16)
        TData(3) = Convert.ToByte(Text_D3.Text, 16)
        TData(4) = Convert.ToByte(Text_D4.Text, 16)
        TData(5) = Convert.ToByte(Text_D5.Text, 16)
        TData(6) = Convert.ToByte(Text_D6.Text, 16)
        TData(7) = Convert.ToByte(Text_D7.Text, 16)

        ret = I8123W.I8123_PDOWrite(SLOT, CobId, 0, Len, TData, BlockMode)
        If ret <> 0 Then
            errstr = "PDO Write Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            DataStr = Text_COBID.Text + ": "

            For i = 0 To (Len - 1)
                DataStr = DataStr + TData(i).ToString("X2") + " "
            Next

            DataStr = DataStr + ": Write OK"

            List_PDOData.Items.Add(DataStr)
        End If
    End Sub

    Private Sub Btn_PDORemote_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_PDORemote.Click
        Dim i As UShort, CobId As UShort
        Dim RLen As Byte
        Dim RData(8) As Byte
        Dim DataStr As String

        CobId = Convert.ToUInt16(Text_COBID.Text, 16)

        ret = I8123W.I8123_PDORemote(SLOT, CobId, RLen, RData, BlockMode)
        If ret <> 0 Then
            errstr = "PDO Remote Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            DataStr = Text_COBID.Text + ": "

            For i = 0 To (RLen - 1)
                DataStr = DataStr + RData(i).ToString("X2") + " "
            Next

            DataStr = DataStr + ": Remote OK"

            List_PDOData.Items.Add(DataStr)
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim Ret As UShort, i As UShort
        Dim IsNew As Byte, Dlen As Byte
        Dim Data(8) As Byte
        Dim DataStr As String

        ' Check PDO data of default TxPDO  
        Ret = I8123W.I8123_GetPDOLastData(SLOT, &H180 + NODE, IsNew, Dlen, Data, BlockMode)
        If (Ret = 0) And (IsNew = 1) Then
            DataStr = (&H180 + NODE).ToString("X") + ": "

            For i = 0 To Dlen - 1
                DataStr = DataStr + Data(i).ToString("X2") + " "
            Next

            DataStr = DataStr + ": Get TxPDO"

            List_PDOData.Items.Add(DataStr)
        End If

        Ret = I8123W.I8123_GetPDOLastData(SLOT, &H280 + NODE, IsNew, Dlen, Data, BlockMode)
        If (Ret = 0) And (IsNew = 1) Then
            DataStr = (&H280 + NODE).ToString("X") + ": "

            For i = 0 To Dlen - 1
                DataStr = DataStr + Data(i).ToString("X2") + " "
            Next

            DataStr = DataStr + ": Get TxPDO"

            List_PDOData.Items.Add(DataStr)
        End If

        Ret = I8123W.I8123_GetPDOLastData(SLOT, &H380 + NODE, IsNew, Dlen, Data, BlockMode)
        If (Ret = 0) And (IsNew = 1) Then
            DataStr = (&H380 + NODE).ToString("X") + ": "

            For i = 0 To Dlen - 1
                DataStr = DataStr + Data(i).ToString("X2") + " "
            Next

            DataStr = DataStr + ": Get TxPDO"

            List_PDOData.Items.Add(DataStr)
        End If

        Ret = I8123W.I8123_GetPDOLastData(SLOT, &H480 + NODE, IsNew, Dlen, Data, BlockMode)
        If (Ret = 0) And (IsNew = 1) Then
            DataStr = (&H480 + NODE).ToString("X") + ": "

            For i = 0 To Dlen - 1
                DataStr = DataStr + Data(i).ToString("X2") + " "
            Next

            DataStr = DataStr + ": Get TxPDO"

            List_PDOData.Items.Add(DataStr)
        End If
    End Sub
End Class
