Imports I8123W_Net

Public Class Form1

    Dim SLOT As Byte
    Dim BAUD As Byte
    Dim NODE As Byte

    Dim BlockMode As Byte = 1

    Dim IsAdd(128) As Byte

    Dim DelayTime As UInt16
    Dim ret As UInt16
    Dim errstr As String

    Private Sub UpdataList()
        Dim a_SyncId(5) As UShort, a_Timer(5) As UShort
        Dim a_Times(5) As UInt32

        List_SYNCID.Items.Clear()

        ret = I8123W.I8123_GetCyclicSYNCInfo(SLOT, a_SyncId, a_Timer, a_Times, BlockMode)
        If ret = 0 Then
            Dim i As UShort
            Dim Temp_Str As String

            For i = 0 To 4
                If a_SyncId(i) = 0 Then
                    Exit For
                End If

                Temp_Str = "SYNC: " + a_SyncId(i).ToString("X3") + " , Timer: " + a_Timer(i).ToString("D") + " , Times: " + a_Times(i).ToString("D")
                List_SYNCID.Items.Add(Temp_Str)
            Next
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As UShort

        SLOT = 0
        BAUD = 0
        NODE = 1

        Combo_Slot.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Combo_Slot.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 0
        Combo_Node.SelectedIndex = 0

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Pal_SYNC.Enabled = False

        For i = 0 To 128
            IsAdd(i) = 0
        Next
    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Call I8123W.I8123_ShutdownMaster(SLOT)
    End Sub

    Private Sub Combo_Slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Slot.SelectedIndexChanged
        SLOT = Combo_Slot.SelectedIndex
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        BAUD = Combo_Baud.SelectedIndex

        Select Case (BAUD)
            Case 0
                DelayTime = 15
            Case 1
                DelayTime = 7
            Case 2
                DelayTime = 3
            Case 3
            Case 4
                DelayTime = 1
            Case 5
            Case 6
            Case 7
                DelayTime = 0
        End Select
    End Sub

    Private Sub Combo_Node_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Node.SelectedIndexChanged
        NODE = Combo_Node.SelectedIndex + 1

        If IsAdd(NODE) <> 0 Then
            Dim SyncId As UShort = 0

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_Remove.Enabled = True

            Pal_SYNC.Enabled = True

            ret = I8123W.I8123_GetSYNCID(SLOT, NODE, SyncId, BlockMode)
            If ret = 0 Then
                Text_SYNCID.Text = SyncId.ToString("X")
                Text_SYNCID.SelectionStart = Text_SYNCID.TextLength
            End If
        Else
            Btn_Remove.Enabled = False
            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True

            Pal_SYNC.Enabled = False

            Text_SYNCID.Text = ""
        End If
    End Sub

    Private Sub Btn_Initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Initial.Click
        ret = I8123W.I8123_InitMaster(SLOT, 0, BAUD, BlockMode)
        If ret <> 0 Then
            errstr = "Initial Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Slot.Enabled = False
            Combo_Baud.Enabled = False
            Combo_Node.Enabled = True

            Btn_Initial.Enabled = False
            Btn_Initial.Visible = False
            Btn_Shutdown.Enabled = True

            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
        End If
    End Sub

    Private Sub Btn_Shutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Shutdown.Click
        Dim i As UShort = 0

        ret = I8123W.I8123_ShutdownMaster(SLOT)
        If ret <> 0 Then
            errstr = "Shutdown Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Slot.Enabled = True
            Combo_Baud.Enabled = True
            Combo_Node.Enabled = False

            Btn_Initial.Enabled = True
            Btn_Initial.Visible = True
            Btn_Shutdown.Enabled = False

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = True
            Btn_Remove.Enabled = False

            Pal_SYNC.Enabled = False

            List_SYNCID.Items.Clear()

            For i = 0 To 128
                IsAdd(i) = 0
            Next
        End If
    End Sub

    Private Sub Btn_AddNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_AddNode.Click
        ret = I8123W.I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode)
        If ret <> 0 Then
            errstr = "AddNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Dim SyncId As UShort = 0

            IsAdd(NODE) = 1

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_Remove.Enabled = True

            Pal_SYNC.Enabled = True

            ret = I8123W.I8123_GetSYNCID(SLOT, NODE, SyncId, BlockMode)
            If ret = 0 Then
                Text_SYNCID.Text = SyncId.ToString("X")
                Text_SYNCID.SelectionStart = Text_SYNCID.TextLength
            End If
        End If
    End Sub

    Private Sub Btn_Remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Remove.Click
        ret = I8123W.I8123_RemoveNode(SLOT, NODE, BlockMode)
        If ret <> 0 Then
            errstr = "RemoveNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            IsAdd(NODE) = 0

            Btn_Remove.Enabled = False
            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True

            Pal_SYNC.Enabled = False

            Text_SYNCID.Text = ""

            Call UpdataList()

        End If
    End Sub

    Private Sub Check_Is_Dec(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Text_SYNCTimes.KeyPress, Text_SYNCTimer.KeyPress
        If ((("1234567890".IndexOf(e.KeyChar) <> -1) Or (Convert.ToInt16(e.KeyChar) = 8)) = False) Then e.Handled = True
    End Sub

    Private Sub Check_Is_Hex(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Text_SYNCID.KeyPress
        If ((("1234567890ABEDCFabcdef".IndexOf(e.KeyChar) <> -1) Or (Convert.ToInt16(e.KeyChar) = 8)) = False) Then e.Handled = True
    End Sub

    Private Sub Btn_SendSYNC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SendSYNC.Click
        Dim SyncId As UShort, Timer As UShort
        Dim Times As UInt32

        SyncId = Convert.ToUInt16(Text_SYNCID.Text, 16)
        Timer = Convert.ToUInt16(Text_SYNCTimer.Text, 10)
        Times = Convert.ToUInt32(Text_SYNCTimes.Text, 10)

        ret = I8123W.I8123_SendSYNCMsg(SLOT, SyncId, Timer, Times, BlockMode)
        If ret <> 0 Then
            errstr = "SendSYNCMsg Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Call UpdataList()
        End If
    End Sub

    Private Sub Btn_SYNCID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SYNCID.Click
        Dim SyncId As UShort

        SyncId = Convert.ToUInt16(Text_SYNCID.Text, 16)

        ret = I8123W.I8123_ChangeSYNCID(SLOT, NODE, SyncId, BlockMode)
        If ret <> 0 Then
            errstr = "ChangeSYNCID Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        End If

        ret = I8123W.I8123_GetSYNCID(SLOT, NODE, SyncId, BlockMode)
        If ret = 0 Then
            Text_SYNCID.Text = SyncId.ToString("X")
            Text_SYNCID.SelectionStart = Text_SYNCID.TextLength
        End If
    End Sub
End Class
