Imports I8123W_Net

Public Class Form1

    Dim SLOT As Byte
    Dim BAUD As Byte
    Dim NODE As Byte

    Dim BlockMode As Byte = 1

    Dim NODE_CNT As Byte

    Dim DelayTime As UInt16
    Dim ret As UInt16
    Dim errstr As String

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SLOT = 0
        BAUD = 0
        NODE = 1
        NODE_CNT = 0

        Combo_Slot.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Combo_Slot.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 0

        Btn_AddNode.Enabled = False
        Btn_Remove.Enabled = False
        Btn_ScanNode.Enabled = False

    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Call I8123W.I8123_ShutdownMaster(SLOT)
    End Sub

    Private Sub Combo_Slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Slot.SelectedIndexChanged
        SLOT = Combo_Slot.SelectedIndex
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        BAUD = Combo_Baud.SelectedIndex

        Select Case (BAUD)
            Case 0
                DelayTime = 15
            Case 1
                DelayTime = 7
            Case 2
                DelayTime = 3
            Case 3
            Case 4
                DelayTime = 1
            Case 5
            Case 6
            Case 7
                DelayTime = 0
        End Select
    End Sub

    Private Sub Combo_Node_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Node.SelectedIndexChanged
        If NODE_CNT <> 0 Then NODE = Val(Combo_Node.Text)
    End Sub

    Private Sub Btn_Initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Initial.Click

        ret = I8123W.I8123_InitMaster(SLOT, 0, BAUD, BlockMode)
        If ret <> 0 Then
            errstr = "Initial Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Slot.Enabled = False
            Combo_Baud.Enabled = False
            Combo_Node.Enabled = True

            Btn_Initial.Enabled = False
            Btn_Initial.Visible = False
            Btn_Shutdown.Enabled = True

            Btn_AddNode.Enabled = True
            Btn_Remove.Enabled = True
            Btn_ScanNode.Enabled = True
        End If
    End Sub

    Private Sub Btn_Shutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Shutdown.Click

        ret = I8123W.I8123_ShutdownMaster(SLOT)
        If ret <> 0 Then
            errstr = "Shutdown Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Slot.Enabled = True
            Combo_Baud.Enabled = True
            Combo_Node.Enabled = False

            Btn_Initial.Enabled = True
            Btn_Initial.Visible = True
            Btn_Shutdown.Enabled = False

            Btn_AddNode.Enabled = False
            Btn_Remove.Enabled = False
            Btn_ScanNode.Enabled = False
        End If
    End Sub

    Private Sub Btn_AddNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_AddNode.Click
        ret = I8123W.I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode)
        If ret <> 0 Then
            errstr = "AddNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Dim NodeList(16) As Byte
            Dim Temp_Node As Byte = 0
            Dim i As UShort, j As UShort, Flag As UShort = 0
            Dim NodeNumber As String

            ret = I8123W.I8123_GetNodeList(SLOT, NodeList, BlockMode)
            If ret <> 0 Then
                errstr = "Node List Get Error, = " + ret.ToString("D")
                MessageBox.Show(errstr)
            Else
                List_NodeList.Items.Clear()
                ' NodeList[0] is node 0 ~ 7
                ' NodeList[1] is node 8 ~ 15
                ' ...
                ' NodeList[15] is node 120 ~ 127

                For i = 0 To 15
                    Flag = 1

                    For j = 0 To 7
                        If (NodeList(i) And Flag) <> 0 Then
                            NodeNumber = "Node " + Temp_Node.ToString("D3") + " under controll"
                            List_NodeList.Items.Add(NodeNumber)
                        End If

                        Temp_Node = Temp_Node + 1
                        Flag = Flag * 2
                    Next
                Next
            End If
        End If
    End Sub

    Private Sub Btn_Remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Remove.Click
        ret = I8123W.I8123_RemoveNode(SLOT, NODE, BlockMode)
        If ret <> 0 Then
            errstr = "RemoveNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Dim NodeList(16) As Byte
            Dim Temp_Node As Byte = 0
            Dim i As UShort, j As UShort, Flag As UShort = 0
            Dim NodeNumber As String

            ret = I8123W.I8123_GetNodeList(SLOT, NodeList, BlockMode)
            If ret <> 0 Then
                errstr = "Node List Get Error, = " + ret.ToString("D")
                MessageBox.Show(errstr)
            Else
                List_NodeList.Items.Clear()
                ' NodeList[0] is node 0 ~ 7
                ' NodeList[1] is node 8 ~ 15
                ' ...
                ' NodeList[15] is node 120 ~ 127

                For i = 0 To 15
                    Flag = 1

                    For j = 0 To 7
                        If (NodeList(i) And Flag) <> 0 Then
                            NodeNumber = "Node " + Temp_Node.ToString("D3") + " under controll"
                            List_NodeList.Items.Add(NodeNumber)
                        End If

                        Temp_Node = Temp_Node + 1
                        Flag = Flag * 2
                    Next
                Next
            End If
        End If
    End Sub

    Private Sub Btn_ScanNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_ScanNode.Click
        Dim NodeList(16) As Byte
        Dim Temp_Node As Byte = 0
        Dim i As UShort, j As UShort, Flag As UShort = 0
        Dim NodeNumber As String

        ' Set function timeout to 3000 ms
        I8123W.I8123_SetFunctionTimeout(SLOT, 3000)

        ' Scan total node to check witch nodes are on the CANopen bus
        ret = I8123W.I8123_ScanNode(SLOT, 0, 0, NodeList, BlockMode)
        If ret <> 0 Then
            errstr = "Node Scan Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            ' Set function timeout to 1000 ms (default value)
            I8123W.I8123_SetFunctionTimeout(SLOT, 1000)

            Combo_Node.Items.Clear()
            ' NodeList[0] is node 0 ~ 7
            ' NodeList[1] is node 8 ~ 15
            ' ...
            ' NodeList[15] is node 120 ~ 127

            For i = 0 To 15
                Flag = 1

                For j = 0 To 7
                    If (NodeList(i) And Flag) <> 0 Then
                        NodeNumber = Temp_Node.ToString("D3")
                        Combo_Node.Items.Add(NodeNumber)
                        NODE_CNT = NODE_CNT + 1
                    End If

                    Temp_Node = Temp_Node + 1
                    Flag = Flag * 2
                Next
            Next

            If Combo_Node.Items.Count <> 0 Then
                Combo_Node.Enabled = True
                Btn_AddNode.Enabled = True
                Btn_Remove.Enabled = True
            Else
                Combo_Node.Items.Add("None Slave!")

                Combo_Node.Enabled = False
                Btn_AddNode.Enabled = False
                Btn_Remove.Enabled = False

                NODE = 0
            End If

            Combo_Node.SelectedIndex = 0
        End If
    End Sub
End Class
